﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.IO;
using C1.Web.Wijmo.Controls.C1GridView;
using System.Text;

namespace C1GridView_ExportToExcel
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (IsPostBack)
            {
                return;
            }
            DataTable dt = new DataTable();
            dt.Columns.Add("ccode");
            dt.Columns.Add("ccode_name");
            dt.Columns.Add("igrade");
            dt.Columns.Add("dend");
            dt.Columns.Add("DateTime", typeof(System.DateTime));
            dt.Columns.Add("Double", typeof(System.Double));


            for (int i = 0; i < 100; i++)
            {
                dt.Rows.Add((i + 1), 2, 3, 4, DateTime.Now, 125.45);
            }

            C1GridView2.DataSource = dt;
            C1GridView2.DataBind();
            C1GridView2.AllowPaging = false;

            C1GridView2.Focus();
        }

        protected override void Render(HtmlTextWriter writer)
        {
            base.Render(writer);
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            StringWriter stringWrite = new StringWriter();
            HtmlTextWriter htmlWrite=new HtmlTextWriter(stringWrite);

            C1GridView dg=new C1GridView();
            dg=this.C1GridView2;

            dg.HeaderStyle.ForeColor = System.Drawing.Color.Black;
            dg.RowStyle.ForeColor = System.Drawing.Color.Black;
 
            dg.AllowSorting = false;
            dg.AllowPaging = false;
            dg.AllowCustomPaging = false;

            Control parent=dg.Parent;
            //parent.Controls.Remove(dg);
 
            dg.RenderControl(htmlWrite);
 
            parent.Controls.Add(dg);

            string content = stringWrite.ToString();

            HttpResponse response=this.Response;
            response.Clear();
            response.Buffer = true;
            response.Charset = "";
            response.ContentType = "application/vnd.ms-excel";
            response.ContentEncoding = new UTF8Encoding();
            response.Write(content);
            response.End();
        }

        public override void VerifyRenderingInServerForm(Control control)
        {
        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            C1.C1Excel.C1XLBook excelBook = new C1.C1Excel.C1XLBook();

            excelBook.Sheets.Add("C1GridView");
            C1.C1Excel.XLSheet sheet = excelBook.Sheets[0];

            int rowCount = this.C1GridView2.Rows.Count;
            int colCount = this.C1GridView2.Columns.Count;

            for (int i = 0; i < rowCount; i++)
			{
                C1.C1Excel.XLRow row=new C1.C1Excel.XLRow();
                sheet.Rows.Add(row);
			}
            
            for (int i = 0; i < colCount; i++)
			{
                C1.C1Excel.XLColumn col=new C1.C1Excel.XLColumn();
                sheet.Columns.Add(col);
			}

            for (int i = 0; i < rowCount; i++)
            {
                for (int j = 0; j < colCount; j++)
                {

                    string text = this.C1GridView2.Rows[i].Cells[j].Text;
                    sheet[i, j].SetValue(text, null);
                }
            }

            excelBook.Save(this.Server.MapPath("test.xls"));
        }
    }
}